﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Assets.Scripts;

[RequireComponent(typeof(Animator))]
public class GuyAnimator : MonoBehaviour {

    private Animator animator;
    public int layerCounter = 0;
    public bool pressed = false;
    public float jumpValue = 0.0f;

    public List<GameObject> weapons;

    private GameObject currentWeapon = null;
    public Transform weaponBone = null;

	// Use this for initialization
	void Start () {
        weaponBone = transform.FindDeepChild ("weapon_dock");
        animator = GetComponent<Animator>();
        layerCounter = animator.layerCount;
        animator.SetLayerWeight(1, 0);

        if (weapons.Count > 0)
        {
            setWeapon(0);
        }
        
    }

    private void setWeapon(int nr)
    {
        if (nr < weapons.Count)
        {
            if (currentWeapon != null)
            {
                DestroyImmediate(currentWeapon,true);
            }
            currentWeapon = Instantiate(weapons[nr]);
            currentWeapon.transform.position = weaponBone.transform.position;
            currentWeapon.transform.parent = weaponBone.transform;
            currentWeapon.transform.localPosition = new Vector3(0, 0, 0); // Set local position so that hat sits on top of the head.
            currentWeapon.transform.localRotation = Quaternion.identity; // Zero hat's rotation.
        }
    }
	
	// Update is called once per frame
	void Update () {
        if (LevelMode.InSetMode())
        {
            return;
        }
        if ((jumpValue = Input.GetAxis("Fire1")) > 0)
        {
            if (!pressed)
            {
                showAiming(true);
                pressed = true;
            }
        }
        else if (pressed)
        {
            showAiming(false);
            pressed = false;
        }

    }

    public void showAiming(bool showit)
    {
        if (showit)
        {
            animator.SetLayerWeight(1, 1);
            animator.SetTrigger("DoTrigger");
        } else
        {
            animator.SetLayerWeight(1, 0);
            animator.SetTrigger("DoTrigger");
        }
    }

    public void doit() {
        animator.SetTrigger("DoTrigger");
        Debug.Log("DOIT! DOIT!");
    }

    void OnCollisionEnter(Collision collision)
    {
        Debug.Log("Collision ENTER:" + collision.collider.name+" =>"+collision.collider.tag);
        if (collision.collider.tag == "enemy")
        {
            Debug.Log("RESTART VIA Collision");
            LevelMode.restart();
        }
        

    }
}
