﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpawnPoint : MonoBehaviour {

    public GameObject target;
    public GameObject spawnPrefab;
    public float spawnTime = 4.0f;
    private float currentTimer = 0;
    public int amount = 10;

	// Use this for initialization
	void Start () {
        LevelMode.CURRENT.addEnemies(amount);
	}
	
	// Update is called once per frame
	void Update () {
        if (amount <= 0 || LevelMode.InSetMode())
        {
            return;
        }

        if (currentTimer <= 0)
        {
            GameObject spawner = Instantiate(spawnPrefab);
            spawner.transform.position = transform.position;
            Enemy enemy = spawner.GetComponent<Enemy>();
            enemy.target = target;
            currentTimer = spawnTime;
            amount--;
        } else
        {
            currentTimer -= Time.deltaTime;
        }
	}
}
