﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TriggerForwarder : MonoBehaviour {

    public class ForwardedResult
    {
        public GameObject sender;
        public Collider collider;
    }

    public GameObject forwardTo;

	// Use this for initialization
	void Start () {
		if (forwardTo == null)
        {
            forwardTo = transform.parent.gameObject;
        }
	}
	
	// Update is called once per frame
	void Update () {
        Debug.Log("FORWARDER");
	}

    void OnTriggerEnter(Collider collider)
    {
        Debug.Log("FORWARDER:" + collider.name);
        ForwardedResult result = new ForwardedResult();
        result.collider = collider;
        result.sender = this.gameObject;
        forwardTo.SendMessage("OnForwardedEnter", result);
    }

    void OnTriggerExit(Collider collider)
    {
        ForwardedResult result = new ForwardedResult();
        result.collider = collider;
        result.sender = this.gameObject;
        forwardTo.SendMessage("OnForwardedExit", result);
    }

}
