﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpringTrap : MonoBehaviour {

    private Animator animator;
    private List<Collider> onTRAP = new List<Collider>();
    private bool fired = false;
    public Material deactivatedMaterial;
    private AudioSource sound;

    void Awake()
    {
        animator = GetComponent<Animator>();
        animator.speed = 0;
    }



	// Use this for initialization
	void Start () {
        sound = GetComponent<AudioSource>();
        sound.volume = 0.2f;
        sound.pitch = 1.5f;
	}
	
	// Update is called once per frame
	void Update () {
        if (LevelMode.InSetMode())
        {
            return;
        }
    }

    void OnTriggerEnter(Collider other)
    {
        if (LevelMode.InSetMode())
        {
            return;
        }
        if (other.tag=="Player" || fired)
        {
            return;
        }
        fired = true;
        sound.Play();
        animator.speed = 1;
        Debug.Log("TRIGGGER:" + other.name+ " TAG:"+other.tag);
        kickThem();

    }

    public void OnForwardedEnter(TriggerForwarder.ForwardedResult result)
    {
        if (LevelMode.InSetMode())
        {
            return;
        }
        onTRAP.Add(result.collider);
        Debug.Log("ENTERED:" + result.collider.name);

    }

    public void OnForwardedExit(TriggerForwarder.ForwardedResult result)
    {
        if (LevelMode.InSetMode())
        {
            return;
        }
        onTRAP.Remove(result.collider);
        Debug.Log("LEFT:" + result.collider.name);
    }

    void kickThem()
    {
        foreach (Collider collider in onTRAP)
        {
            Debug.Log("SPRING JUMP CALL!" + collider.name);
            collider.SendMessage("springJump",transform);
        }
        onTRAP.Clear();
    }

    public void onDeactivate()
    {
        Renderer renderer = GetComponentInChildren<Renderer>();
        Material[] mats = renderer.materials;
        mats[0] = deactivatedMaterial;
        renderer.materials = mats;
    }

}
